package com.dayou.controller;

import com.dayou.common.RestResponse;
import com.dayou.dto.MajorAppraiserUnitDTO;
import com.dayou.service.IMajorAppraiserUnitService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
 * 大中型估价人员计件数(人力资源部统计)
 *
 * @author wucl
 * @since 2025-06-26
 */
@RestController
@RequestMapping("majorAppraiserUnit")
@Slf4j
public class MajorAppraiserUnitController {

    @Autowired
    private IMajorAppraiserUnitService majorAppraiserUnitService;

    /**
     * 分配计件数
     * @param majorAppraiserUnitDTO
     * @return
     */
    @PostMapping("")
    public RestResponse<Boolean> save(@RequestBody @Valid MajorAppraiserUnitDTO majorAppraiserUnitDTO) {
        Boolean ret = majorAppraiserUnitService.saveUnit(majorAppraiserUnitDTO);
        return RestResponse.success(ret);
    }

    /**
     * 查询计件数
     * @param id
     * @return
     */
    @GetMapping("/{id}")
    public RestResponse<MajorAppraiserUnitDTO> select(@PathVariable("id") Long id){
        MajorAppraiserUnitDTO ret = majorAppraiserUnitService.select(id);
        return RestResponse.success(ret);
    }
}
